# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def export_chatlist_invite(*, chatlist: abcs.InputChatlist, title: str, peers: Sequence[abcs.InputPeer]) -> Request[abcs.chatlists.ExportedChatlistInvite]:
    _buffer = bytearray(b'\x8eGr\x84')
    chatlist._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, title.encode('utf-8'))
    _buffer += struct.pack('<ii', 0x1cb5c415, len(peers))
    for _t0 in peers:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def delete_exported_invite(*, chatlist: abcs.InputChatlist, slug: str) -> Request[bool]:
    _buffer = bytearray(b'^\\\x9cq')
    chatlist._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, slug.encode('utf-8'))
    return Request(b'' + _buffer)
def edit_exported_invite(*, chatlist: abcs.InputChatlist, slug: str, title: Optional[str], peers: Optional[Sequence[abcs.InputPeer]]) -> Request[abcs.ExportedChatlistInvite]:
    _buffer = bytearray(b'=\xb6=e')
    flags = (0 if title is None else 2) | (0 if peers is None else 4)
    _buffer += struct.pack('<I', flags)
    chatlist._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, slug.encode('utf-8'))
    if title is not None:
      serialize_bytes_to(_buffer, title.encode('utf-8'))
    if peers is not None:
      _buffer += struct.pack('<ii', 0x1cb5c415, len(peers))
      for _t0 in peers:
        _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_exported_invites(*, chatlist: abcs.InputChatlist) -> Request[abcs.chatlists.ExportedInvites]:
    _buffer = bytearray(b'\x83\xda\x03\xce')
    chatlist._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def check_chatlist_invite(*, slug: str) -> Request[abcs.chatlists.ChatlistInvite]:
    _buffer = bytearray(b'\xff\x0f\xc1A')
    serialize_bytes_to(_buffer, slug.encode('utf-8'))
    return Request(b'' + _buffer)
def join_chatlist_invite(*, slug: str, peers: Sequence[abcs.InputPeer]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\x9a\xe3\xb1\xa6')
    serialize_bytes_to(_buffer, slug.encode('utf-8'))
    _buffer += struct.pack('<ii', 0x1cb5c415, len(peers))
    for _t0 in peers:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_chatlist_updates(*, chatlist: abcs.InputChatlist) -> Request[abcs.chatlists.ChatlistUpdates]:
    _buffer = bytearray(b'!\x95A\x89')
    chatlist._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def join_chatlist_updates(*, chatlist: abcs.InputChatlist, peers: Sequence[abcs.InputPeer]) -> Request[abcs.Updates]:
    _buffer = bytearray(b'\xf5\xf8\x89\xe0')
    chatlist._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(peers))
    for _t0 in peers:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def hide_chatlist_updates(*, chatlist: abcs.InputChatlist) -> Request[bool]:
    _buffer = bytearray(b'\xfb\x86\xe4f')
    chatlist._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_leave_chatlist_suggestions(*, chatlist: abcs.InputChatlist) -> Request[Sequence[abcs.Peer]]:
    _buffer = bytearray(b'\x14\xd7\xbc\xfd')
    chatlist._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def leave_chatlist(*, chatlist: abcs.InputChatlist, peers: Sequence[abcs.InputPeer]) -> Request[abcs.Updates]:
    _buffer = bytearray(b':\xe1\xfat')
    chatlist._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', 0x1cb5c415, len(peers))
    for _t0 in peers:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
